10 REM ********** DEFENDER.BAS **********
15 REM --- Initialize and Redefine ---
20 REDEFINE 91,0,32,72,16,40,36,64,0
21 REDEFINE 92,0,36,72,22,185,52,72,146
22 REDEFINE 93,0,0,0,16,8,32,72,0
23 REDEFINE 94,20,0,20,0,20,62,127,42
24 REDEFINE 123,0,240,32,126,63,14,0,0
25 REDEFINE 124,0,60,36,126,255,126,0,0
26 REDEFINE 125,0,128,64,126,255,126,64,128
27 REDEFINE 126,24,24,24,24,24,60,0,16
28 r=0   REM <-- High Score This Session
30 a=51  REM <-- Ship One Column
32 b=7   REM <-- Ship One Row
34 c=6   REM <-- Ship One "Type"
36 d=60  REM <-- Ship Two Column
38 e=11  REM <-- Ship Two Row
40 f=4   REM <-- Ship Two Type
42 g=63  REM <-- Ship Three Column
44 h=15  REM <-- Ship Three Row
46 i=5   REM <-- Ship Three Type
52 L=25  REM <-- Launcher Column
54 m=25  REM <-- Missile Column
56 n=-1  REM <-- Missile Row
58 s=0   REM <-- Current Score
60 t=999 REM <-- Countdown Timer
62 u=0   REM <-- User Input
64 v=0   REM <-- User Input
68 w=10  REM <-- Ship Speed Divisor
70 x=0
72 y=0
74 z=0
100 REM --- Draw Intro Screen ---
105 COLOR 63,0
110 CLS 
115 IF t=999 AND r=0 THEN GOSUB 1200
120 REM ... Generate Random Ship Start Postions ...
125 a=50+RND (6): b=2+RND (20): c=5+RND (5)
130 g=50+RND (5): h=2+RND (20): i=5+RND (5)
200 REM --- Start of Main Loop ---
205 COLOR 32,3
210 LOCATE 21,0: PRINT "  PLANET  ";
215 LOCATE 21,1: PRINT " DEFENDER ";
220 COLOR 63,0
225 LOCATE 40,0: PRINT "TIME: ";t;" ";
235 LOCATE 0,0: PRINT "HIGH SCORE: ";r;" "
240 LOCATE 0,1: PRINT "YOUR SCORE: ";s;" "
300 REM --- Missile Launcher Actions ---
302 COLOR 52,0
305 LOCATE L,36: DISPLAY 32
310 u=INKEY 
315 IF u=192 AND L>0 THEN L=L-1
320 IF u=193 AND L<49 THEN L=L+1
325 IF u=194 AND n=-1 THEN m=L: n=35
350 LOCATE L,36: DISPLAY 94
400 REM --- Spaceship Actions ---
405 REM ... Move Ship Every 10th Click of Timer
408 IF t//33=0 THEN w=8+RND (4)
410 IF (t//w)<>0 THEN GOTO 600
415 LOCATE a,b: DISPLAY 32
420 a=a-1
425 COLOR c,0
430 IF a>=0 AND a<=49 THEN LOCATE a,b: DISPLAY 123
435 IF a=-1 THEN GOSUB 1100
450 LOCATE d,e: DISPLAY 32
455 d=d-1
460 COLOR f,0
465 IF d>=0 AND d<=49 THEN LOCATE d,e: DISPLAY 124
470 IF d=-1 THEN GOSUB 1100
475 LOCATE g,h: DISPLAY 32
480 g=g-1
485 COLOR i,0
490 IF g>=0 AND g<=49 THEN LOCATE g,h: DISPLAY 125
495 IF g=-1 THEN GOSUB 1100
600 REM --- Missile Actions ---
605 IF n=-1 THEN GOTO 800
610 IF n<=35 AND n>=2 THEN LOCATE m,n: DISPLAY 32
615 n=n-1
620 COLOR 63,0
625 IF n<=35 AND n>=2 THEN LOCATE m,n: DISPLAY 126
700 REM ... Check for Hit ...
705 IF a<>m OR b<>n THEN GOTO 735
710 LOCATE a,b
715 a=-2  REM <-- Move Ship to Destroyed Column
720 n=-1  REM <-- Load New Missile on Launcher
725 GOSUB 1000
730 GOTO 800
735 IF d<>m OR e<>n THEN GOTO 765
740 LOCATE d,e
745 d=-2  REM <-- Destroyed Ship
750 n=-1  REM <-- New Missile
755 GOSUB 1000
760 GOTO 800
765 IF g<>m OR h<>n THEN GOTO 800
770 LOCATE g,h
775 g=-2  REM <-- Destroyed Ship
780 n=-1  REM <-- New Missile
785 GOSUB 1000
800 REM --- Update Score Actions ---
805 IF a>-1 THEN GOTO 840
810 IF a=-1 THEN s=s-c*200
820 IF a=-2 THEN s=s+c*40
825 REM ... Now Rejuvenate Ship One ...
830 a=50+RND (6): b=2+RND (20): c=5+RND (5)
835 GOTO 900
840 IF d>=-1 THEN GOTO 865
845 IF d=-1 THEN s=s-f*500
850 IF d=-2 THEN s=s+f*60
855 d=50+RND (4): e=2+RND (20): f=5+RND (5)
860 GOTO 900
865 IF g>-1 THEN GOTO 900
870 IF g=-1 THEN s=s-i*400
875 IF g=-2 THEN s=s+i*50
880 g=50+RND (5): h=2+RND (20): i=5+RND (5)
900 REM --- End of Main Loop ---
902 t=t-1
904 IF t>=0 THEN GOTO 200
910 REM --- Game Over Actions ---
912 IF r=0 THEN r=s
915 IF s>r THEN r=s
920 COLOR 8,0
925 LOCATE 12,18: PRINT "Game Over!  Play Again (Y/N)?"
930 v=INKEY 
935 IF v<>"Y" AND v<>"y" AND v<>"N" AND v<>"n" THEN GOTO 930
940 IF v="Y" OR v="y" THEN GOTO 30
945 COLOR 63,22
950 CLS 
960 PRINT "Bye!"
990 END 
995 REM ***** Subroutines *****
1000 REM --- Missile Hit Explosion ---
1005 COLOR 60,0
1010 DISPLAY 91,8
1012 PLUCK 25
1015 PAUSE 50
1020 COLOR 52,0
1025 DISPLAY 92,8
1027 PLUCK 18
1030 PAUSE 100
1035 COLOR 32,0
1040 DISPLAY 93,8
1042 PLUCK 10
1045 PAUSE 150
1050 DISPLAY 32,8
1052 GOSUB 1300
1055 RETURN 
1100 REM --- City Bombing Skyflash ---
1105 COLOR 63,60
1110 CLS 
1112 NOTEON 5
1115 PAUSE 50
1120 COLOR 63,52
1125 CLS 
1130 PAUSE 50
1135 COLOR 63,32
1140 CLS 
1145 PAUSE 50
1150 COLOR 63,0
1155 CLS 
1157 PAUSE 300
1159 NOTEOFF 
1160 RETURN 
1200 REM --- Draw Intro Screen ---
1202 COLOR 32,3
1205 LOCATE 17,2: PRINT "PLANET DEFENDER"
1207 COLOR 8,0
1210 LOCATE 4,6: PRINT "You are the Commander of a planetary defense"
1212 LOCATE 2,7: PRINT "missile battery charged with the close-in"
1214 LOCATE 2,8: PRINT "protection of the capital city of Argonia."
1216 LOCATE 2,9: PRINT "Your mission is to prevent any Korinic ships"
1218 LOCATE 2,10: PRINT "from crossing the 'last ditch' line, where"
1220 LOCATE 2,11: PRINT "they can then bomb the capital."
1228 PAUSE 3000
1230 LOCATE 2,13: PRINT "   Your battery has plenty of missiles, but"
1232 LOCATE 2,14: PRINT "due to the type of warhead used against Korinic"
1234 LOCATE 2,15: PRINT "ships, only one missile is allowed in flight"
1236 LOCATE 2,16: PRINT "at a time."
1238 PAUSE 3000: COLOR 52,0
1240 LOCATE 2,18: PRINT "> The Left/Right arrow keys move the launcher."
1242 LOCATE 2,19: PRINT "> The Up arrow key fires a missile."
1248 PAUSE 2000: COLOR 63,0
1250 LOCATE 2,26: PRINT "    They are coming, Commander.  Aim well!"
1285 LOCATE 8,28: PRINT ">>> Press <Spacebar> to Start <<<"
1287 u=INKEY 
1289 v=RND (100)  REM <-- Randomize RND Start Value
1291 IF u<>32 THEN GOTO 1287 REM <-- Wait for Spacebar
1293 CLS 
1295 RETURN 
1300 REM --- Bonus Check ---
1305 IF x=0 THEN x=t:RETURN 
1310 IF y=0 THEN y=t: RETURN 
1315 IF z=0 THEN z=t
1320 IF x-z>100 THEN x=y: y=z: z=0: RETURN 
1325 t=t+300
1330 x=0: y=0: z=0
1395 RETURN 
