5 REM *** CIPHER.BAS ***
7 d=0: REM <- Debug Switch (1=ON)
10 m=2681: n=m-250: p=2281: q=p-50
15 COLOR 63,22
20 REM --- Main Loop: F1-F8 Keypress --- 
25 GOSUB 100
30 k=INKEY : IF k<208 OR k>215 THEN GOTO 30
35 GOSUB (k-207)*100
40 GOTO 30
100 REM --- Print Screen ---
105 CLS 
110 LOCATE 12,1: PRINT "AMIGO MAGIC DECODER RING"
115 LOCATE 2,32: PRINT "F1 - CLEAR SCREEN          F5 - DECODE"
120 LOCATE 2,33: PRINT "F2 - ENTER MESSAGE         F6 - LOAD MSG.DAT"
125 LOCATE 2,34: PRINT "F3 - ENTER KEY STRING      F7 - SAVE MSG.DAT"
130 LOCATE 2,35: PRINT "F4 - ENCODE                F8 - QUIT"
195 RETURN 
200 REM --- Enter Message ---
205 e=2781: f=2432: GOSUB 1100
210 LOCATE 2,3: PRINT "> Enter Message String:"
215 u=m: v=m-250
220 GOSUB 900
225 n=w+1
228 IF d THEN b=228: GOSUB 1200
295 RETURN 
300 REM --- Enter Key ---
305 e=2381: f=2232: GOSUB 1100
320 LOCATE 2,11: PRINT "> Enter Key String:"
325 u=p: v=p-50
330 GOSUB 900
335 q=w+1
395 RETURN 
400 REM --- Encode ---
405 LOCATE 2,15: PRINT "> Encoded Message:"
410 c=1
415 GOSUB 1000
495 RETURN 
500 REM --- Decode ---
505 LOCATE 2,15: PRINT "> Decoded Message:"
510 c=-1
515 GOSUB 1000
595 RETURN 
600 REM --- Load MSG.DAT ---
605 e=2681: f=2432: GOSUB 1100
610 LOCATE 2,3: PRINT "> Enter Message String:"
615 OPEN "MSG.DAT",R
620 i=m
625 a=FILE 
630 IF a<0 THEN GOTO 650
635 BYTE [i]=a
640 i=i-1
645 GOTO 625
650 CLOSE 
655 n=i+1
658 IF d THEN b=658: GOSUB 1200
695 RETURN 
700 REM --- Save MSG.DAT ---
705 LOCATE 2,25: PRINT "Saving MSG.DAT... ";
710 OPEN "MSG.DAT",W
715 FOR i=m-600 TO n-600 STEP -1
720 FILE =BYTE [i]
725 NEXT i
730 CLOSE 
740 PRINT "Done!"
745 PAUSE 2000
750 LOCATE 2,25: PRINT "                        "
795 RETURN 
800 REM --- Quit ---
805 LOCATE 2,25: PRINT "Quit <Y/N>?"
810 k=INKEY 
815 IF k<>"Y" AND K<>"y" AND k<>"N" AND k<>"n" THEN GOTO 805
820 IF k="Y" OR k="y" THEN GOTO 835
825 LOCATE 2,25: PRINT "           "
830 RETURN 
835 CLS : PRINT "Bye!"
840 END 
900 REM --- Process Keystrokes ---
905 w=u
910 k=INKEY : IF k=0 THEN GOTO 910
915 IF k=13 THEN RETURN 
920 IF k=200 AND w<u THEN w=w+1: BYTE [w]=32: GOTO 910
925 IF k>122 THEN GOTO 910
930 IF k>96 THEN k=k-32
935 IF w>v THEN BYTE [w]=k: w=w-1
940 GOTO 910
1000 REM --- Code/Decode ---
1003 e=2081: f=1832: GOSUB 1100
1005 j=p
1007 IF d THEN b=1007: GOSUB 1200
1010 FOR i=m TO n STEP -1
1015 x=BYTE [i]
1020 IF j<q THEN j=p
1025 y=BYTE [j]
1030 j=j-1
1032 REM ...Rules Follow...
1035 IF y<65 OR y>90 THEN z=x: GOTO 1060
1040 IF x<65 OR x>90 THEN z=x: GOTO 1060
1045 z=x+c*(y-64)
1050 IF z>90 THEN z=z-26: GOTO 1060
1055 IF z<65 THEN z=z+26
1060 BYTE [i-600]=z
1065 NEXT i
1095 RETURN 
1100 REM --- Clear Screen Section ---
1105 h=" "
1110 IF d THEN h="."
1115 FOR g=e TO f STEP -1
1120 BYTE [g]=h
1125 NEXT g
1195 RETURN 
1200 REM --- Debug ---
1203 REM ...Adjust these as needed...
1205 LOCATE 0,29: PRINT "Line ";b;" i=";i;" m=";m;" n=";n;" u=";u;" v=";v;" w=";w
1210 IF INKEY =0 THEN GOTO 1210
1215 e=1481: f=1428: GOSUB 1100
1295 RETURN 
1300 REM --- Variables ---
1302 REM - a=FILE char from/to MSG.DAT
1304 REM - b=debug statement line #
1306 REM - c=encode (1) or decode (-1) switch
1308 REM - d=debug switch (0=OFF)
1310 REM - e,f=start,end screen location of string to clear
1312 REM - g=clear string index
1314 REM - h=clear string char (" "=normal; "."=debug)
1316 REM - j=index for key string
1318 REM - k=keystroke from INKEY
1320 REM - m,n=start,end of plaintext message (up to 250 chars)
1322 REM - p,q=start,end of key string (up to 50 chars)
1324 REM - u,v=start,end of keystroke processing string
1326 REM - w=index for keystroke processing
1328 REM - x=plaintext char
1330 REM - y=key string char
1332 REM - z=coded/decoded char
